#pragma warning disable 108 // new keyword hiding
#pragma warning disable 114 // new keyword hiding
using System;

namespace Windows.UI.Xaml.Media.Animation
{
	public  partial class ExponentialEase
	{
		public  double Exponent
		{
			get
			{
				return (double)this.GetValue(ExponentProperty);
			}
			set
			{
				this.SetValue(ExponentProperty, value);
			}
		}

		public static global::Windows.UI.Xaml.DependencyProperty ExponentProperty { get; } = 
		Windows.UI.Xaml.DependencyProperty.Register(
			"Exponent", typeof(double), 
			typeof(global::Windows.UI.Xaml.Media.Animation.ExponentialEase), 
			new FrameworkPropertyMetadata(
				defaultValue: 1.0,
				propertyChangedCallback: (s, e) => (s as ExponentialEase)?.OnExponentChanged((double)e.OldValue, (double)e.NewValue)
			)
		);

		internal virtual void OnExponentChanged(double oldValue, double newValue)
		{
			OnExponentChangedPartial(oldValue, newValue);
		}

		partial void OnExponentChangedPartial(double oldValue, double newValue);

		public ExponentialEase() 
		{
		}

		public override double Ease(double currentTime, double startValue, double finalValue, double duration)
		{
			var t = currentTime / duration;
			var exponent = Exponent;
			var normalizedValue = (Math.Exp(exponent * t) - 1) / (Math.Exp(exponent) - 1);

			return startValue + (finalValue - startValue) * normalizedValue;
		}
	}
}
